> ## Documentation Index
> Fetch the complete documentation index at: https://apidocs.specurate.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Set Room Quantities



## OpenAPI

````yaml /openapi.json put /v1/workspaces/{workspaceId}/projects/{projectId}/area-allocations/rooms
openapi: 3.1.0
info:
  title: Specurate API
  description: ''
  version: 1.0.0
  contact: {}
servers:
  - url: https://app.specurate.com/api
    description: API Server
security: []
tags: []
paths:
  /v1/workspaces/{workspaceId}/projects/{projectId}/area-allocations/rooms:
    put:
      tags:
        - Project Area Allocations
      summary: Set Room Quantities
      operationId: ProjectAreaAllocationsController_setRoomQuantities_v1
      parameters:
        - name: workspaceId
          required: true
          in: path
          schema:
            type: string
        - name: projectId
          required: true
          in: path
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/UpdateProjectAreaRoomQuantitiesDto'
      responses:
        '200':
          description: ''
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ProjectAreaAllocationMatrixResponseDto'
      security:
        - bearer: []
components:
  schemas:
    UpdateProjectAreaRoomQuantitiesDto:
      type: object
      properties:
        structureVersion:
          type: integer
          exclusiveMinimum: 0
          maximum: 9007199254740991
        slotId:
          type: string
        areaId:
          type: string
        rooms:
          minItems: 1
          maxItems: 500
          type: array
          items:
            type: object
            properties:
              roomIndex:
                type: integer
                minimum: 0
                maximum: 499
              quantity:
                anyOf:
                  - type: string
                    pattern: ^\d{1,16}(?:\.\d{1,6})?$
                  - type: 'null'
              version:
                anyOf:
                  - type: integer
                    exclusiveMinimum: 0
                    maximum: 9007199254740991
                  - type: 'null'
            required:
              - roomIndex
              - quantity
              - version
            additionalProperties: false
      required:
        - structureVersion
        - slotId
        - areaId
        - rooms
      additionalProperties: false
    ProjectAreaAllocationMatrixResponseDto:
      type: object
      properties:
        structureVersion:
          type:
            - number
            - 'null'
        areas:
          type: array
          items:
            $ref: '#/components/schemas/ProjectAreaAllocationAreaResponseDto'
        allocations:
          type: array
          items:
            $ref: '#/components/schemas/ProjectAreaAllocationResponseDto'
        areaQuantities:
          type: array
          items:
            $ref: '#/components/schemas/ProjectAreaQuantityResponseDto'
        systemAllocations:
          type: array
          items:
            $ref: '#/components/schemas/ProjectSystemAreaAllocationResponseDto'
        slotTotals:
          type: array
          items:
            $ref: '#/components/schemas/ProjectAreaAllocationSlotTotalResponseDto'
      required:
        - structureVersion
        - areas
        - allocations
        - areaQuantities
        - systemAllocations
        - slotTotals
    ProjectAreaAllocationAreaResponseDto:
      type: object
      properties:
        areaId:
          type: string
        parentId:
          type:
            - string
            - 'null'
        level:
          type: number
        levelKey:
          type: string
        levelLabel:
          type: string
        code:
          type:
            - string
            - 'null'
        name:
          type: string
        multiplier:
          type: number
        instanceTags:
          type:
            - array
            - 'null'
          items:
            type: string
        effectiveInstanceCount:
          type: string
        ancestorPath:
          type: array
          items:
            $ref: '#/components/schemas/ProjectAreaAllocationAncestorResponseDto'
      required:
        - areaId
        - parentId
        - level
        - levelKey
        - levelLabel
        - code
        - name
        - multiplier
        - instanceTags
        - effectiveInstanceCount
        - ancestorPath
    ProjectAreaAllocationResponseDto:
      type: object
      properties:
        id:
          type: string
        slotId:
          type: string
        areaId:
          type: string
        quantity:
          type: string
        effectiveQuantity:
          type: string
        version:
          type: number
      required:
        - id
        - slotId
        - areaId
        - quantity
        - effectiveQuantity
        - version
    ProjectAreaQuantityResponseDto:
      type: object
      properties:
        slotId:
          type: string
        areaId:
          type: string
        defaultQuantity:
          type:
            - string
            - 'null'
        defaultVersion:
          type:
            - number
            - 'null'
        effectiveQuantity:
          type: string
        roomQuantities:
          type: array
          items:
            $ref: '#/components/schemas/ProjectAreaRoomQuantityResponseDto'
      required:
        - slotId
        - areaId
        - defaultQuantity
        - defaultVersion
        - effectiveQuantity
        - roomQuantities
    ProjectSystemAreaAllocationResponseDto:
      type: object
      properties:
        id:
          type:
            - string
            - 'null'
        slotId:
          type: string
        systemArea:
          type: string
          enum:
            - extra
            - unassigned
        quantity:
          type: string
        version:
          type:
            - number
            - 'null'
      required:
        - id
        - slotId
        - systemArea
        - quantity
        - version
    ProjectAreaAllocationSlotTotalResponseDto:
      type: object
      properties:
        slotId:
          type: string
        effectiveQuantity:
          type: string
        slotQuantity:
          type: string
        unassignedQuantity:
          type: string
        totalQuantity:
          type: string
      required:
        - slotId
        - effectiveQuantity
        - slotQuantity
    ProjectAreaAllocationAncestorResponseDto:
      type: object
      properties:
        id:
          type: string
        code:
          type:
            - string
            - 'null'
        name:
          type: string
      required:
        - id
        - code
        - name
    ProjectAreaRoomQuantityResponseDto:
      type: object
      properties:
        roomIndex:
          type: number
        roomNumber:
          type: string
        quantity:
          type: string
        version:
          type: number
      required:
        - roomIndex
        - roomNumber
        - quantity
        - version
  securitySchemes:
    bearer:
      scheme: bearer
      bearerFormat: JWT
      type: http

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.